/* FILE: trampolin.cpp
*  author: Alessandra Ferrari vr366283 / id084456
*
*/

#include <cassert>
#include <iostream>
#include <cstdlib>
#include <fstream>

using namespace std;
const int MAX_N = 1000000;

int array[MAX_N];
int s_left[MAX_N];
int s_right[MAX_N];
char trampolin[MAX_N];


int main(){
	int n;
	int k;
	int count = 0;
	int best_so_far = 0;
	int l = k-1;
	int r = k-1;
	
	
	ifstream fin("input.txt");
	assert(fin);
	fin >> n >> k;
	for(int i=0; i<n; i++){
		fin >> array[i];
	}
	for(int i=0; i<n; i++){
		fin >> trampolin[i];
	}

	//left
	for(int i=1; i<n; ++i){
		if(array[i] < array[i-1]){
			continue;
		}
		if(trampolin[i-1] == 'T'){
			trampolin[i]='T';
		}
		s_left[i] = 1 + s_left[i-1];
	}

	//right
	for(int i=n-2; i>=0;--i){
		if(array[i]<array[i+1]){
		 continue;
		}
		if(trampolin[i+1] == 'T'){
			trampolin[i]='T';
		}
		s_right[i] = 1 + s_right[i+1];
	}

	
	//calcola l'ottimo
	for(int i=0; i<n; i++){
		if(trampolin[i] == 'T'){
			++count;
		}else{
			best_so_far = max(best_so_far, 1 + max(s_left[i], s_right[i]));
		}
	}
	ofstream fout("output.txt");
	assert(fout);
	if(trampolin[k-1] == 'T'){
		//cout << count + best_so_far << endl;
		fout << count + best_so_far;
	}else{
		
		while( l>0 && array[l-1] == array[k-1]){
			l--;
		}
		while( r<n-1 && array[r+1] == array[k-1]){
			r++;
		}
		//cout << r-l+1+max(s_left[l], s_right[r]) << endl;
		fout << r-l+1+max(s_left[l], s_right[r]);
	}
	fout.close();
	return 0;
}



