/*
 * permutGame.cpp
 *
 *  Created on: 02/lug/2013
 *      Author: id091801
 */

#include <cstdio>
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <list>
#include <vector>
#include <cassert>

using namespace std;

vector<vector<int> > perm;
vector<vector<vector<int> > > switchDone;
int num_perm, num_elem;

void print();
int getFirstUnmatchItem(vector<int> p);
void switchPosition(int num, vector<int> &p, int i);
int notSolved();
int lookPerm(vector<int> p);

int main() {
	FILE *fin, *fout;
	fin = fopen("input.txt", "r");
	fout = fopen("output.txt", "w");
	fscanf(fin, "%d %d\n", &num_elem, &num_perm);

	perm.resize(num_perm + 1);
	switchDone.resize(num_perm + 1);

	for (int i = 1; i <= num_perm; i++) {
		vector<int> tmp;
		tmp.resize(num_elem + 1);
		for (int j = 1; j <= num_elem; j++) {
			fscanf(fin, "%d ", &tmp[j]);
		}
		perm[i] = tmp;
	}


	while(true) {
		print();
		if(notSolved()<=1){
			printf("Solo una non è risolta.\n");
			for(int i=1; i<=num_perm; i++) {
				int index = getFirstUnmatchItem(perm[i]);
				printf("P[%d] ",i);
				if(index!=-1) {
					printf("non è risolta\n");
					int num = lookPerm(perm[i]);
					printf("Quanti numeri ho fuori posto? %d\n",num);
					if((num/2)%2!=0) {
						printf("Ho un numero dispari di scambi da fare.\nRisolvo %d permutazioni",num_perm-1);
						fprintf(fout,"%d",num_perm-1);
						exit(-1);
					} else {
						break;
					}
				} else {
					printf("risolta\n");
				}
			}
		} else {
			printf("Ho almeno due permutazioni non risolte\n");
			for(int i=1; i<=num_perm; i++) {
				switchPosition(i, perm[i], getFirstUnmatchItem(perm[i]));
			}
		}
	}


	printf("IRRISOLVIBILE");

	// Chiudo il file di input
	fclose(fin);

	fprintf(fout, "\n");

	// Chiudo il file di output
	fclose(fout);
}

void print() {
	printf("\n#-------------------------------\n");
	printf("| Lista delle permutazioni\n");
	printf("#-------------------------------\n");
	for (int i = 1; i <= num_perm; i++) {
		printf("| P[%d]:\t", i);
		vector<int> tmp = perm[i];
		for (int j = 1; j <= num_elem; j++) {
			printf("%d ", tmp[j]);
		}
		printf("\n");
	}
	/*
	 printf("#-------------------------------\n");
	 printf("| Lista degli scambi\n");
	 printf("#-------------------------------\n");
	 for(int i=1; i<=num_perm; i++) {
	 printf("| P[%d]:\t",i);
	 vector<vector<int> > actualswitch = switchDone[i];
	 for(unsigned j=0; j<actualswitch.size(); j++) {
	 vector<int> tmp = actualswitch[j];
	 printf("(%d,%d) ",tmp[0],tmp[1]);
	 }
	 printf("\n");
	 }
	 */
	printf("#-------------------------------\n\n");
}

int getFirstUnmatchItem(vector<int> p) {
	for (int i = 1; i <= num_elem; i++) {
		if ((i) == p[i]) {
			continue;
		} else {
			return i;
		}
	}
	return -1;
}

int lookPerm(vector<int> p) {
	int count = 0;
	for (int i = 1; i <= num_elem; i++) {
		if ((i) == p[i]) {
			continue;
		} else {
			count++;
		}
	}
	return count;
}

int notSolved() {
	int count = 0;
	for(int i=1; i<=num_perm; i++) {
		if(getFirstUnmatchItem(perm[i])==-1) {
			continue;
		} else {
			count++;
		}
	}
	return count;
}

void switchPosition(int num, vector<int> &p, int i) {
	if (i < 0) {
		p[1] = 2;
		p[2] = 1;
		printf("\nP[%d] - scambio (1,2)\n",num);
		return;
	}
	int x = p[i];
	int y = p[x];

	printf("\nP[%d] - scambio (%d,%d)\n",num, x, y);

	p[i] = y;
	p[x] = x;

	/*
	 vector<vector<int> > actualswitch = switchDone[num];
	 actualswitch.resize(actualswitch.size()+1);
	 vector<int> newswitch = actualswitch.back();
	 newswitch[0] = x;
	 newswitch[1] = y;
	 actualswitch.pop_back();
	 actualswitch.push_back(newswitch);
	 switchDone[num] = actualswitch;
	 */
}

