#include <cstdio>
#include <stdlib.h>
#include <stdio.h>
#include <vector>
#include <iostream>

using namespace std;

vector<int> h, sx_value, dx_value, mask;
int num_skysc, startPosition;

char tramp[500000];

int max(int x, int y);
void printSkysc();

int main2() {

	FILE *fin, *fout;
	fin = fopen("input.txt", "r");

	fscanf(fin, "%d%d\n", &num_skysc, &startPosition);
	// parte da 0 l'array
	--startPosition;

	//printf("Situazione iniziale: %d grattacieli\nPartenza da: %d", num_skysc,startPosition);

	h.resize(num_skysc);
	sx_value.resize(num_skysc, 0);
	dx_value.resize(num_skysc, 0);

	// ottengo l'elenco dei grattacieli
	for (int i = 0; i < num_skysc; i++) {
		fscanf(fin, "%d", &h[i]);
	}
	//printf(" - h: %d\n\n", h[startPosition]);
	// ottengo l'elenco dei trampolini
	fscanf(fin, "%s", tramp);

	//printSkysc();

	fclose(fin);

	/*
	 * Calcolo il massimo ottenibile per ogni grattacielo se saltassi sempre a sinistra.
	 * Parto dal secondo
	 * Se l'adiacente è più alto lo ignoro
	 * Se l'adiacente ha un trampolino "fondo" i due dandogli il valore pari alla somma e piazzando un trampolino sul risultante
	 * Aggiorno comunque il valore di questo grattacielo facendo un salto sul prossimo
	 */
	//printf("Analisi lato SINISTRO\n");
	for (int i = 1; i < num_skysc; ++i) {
		int next = i-1;
		//printf("Guardo %d° grattacielo: '%d'\n", i + 1, h[i]);
		if (h[i] < h[next]) {
			//printf(" -> E' più basso di quello alla sua sx (%d<%d)\n", h[i],h[next]);
			continue;
		} else {
			//printf(" -> E' più alto di quello alla sua sx (%d>%d)\n", h[i], h[next]);
			if (tramp[next] == 'T') {
				//printf(" -> Il grattacielo alla sua sx ha il trampolino\n",h[i], h[next]);
				//printf(" -> Aggiungo il trampolino");
				tramp[i] = 'T';
			}
			sx_value[i] = 1 + sx_value[next];
			//printf(" -> Nuovo valore: %d\n", sx_value[i]);
		}
	}
	//printf("\n");

	//printSkysc();


	/*
	 * Calcolo il massimo ottenibile per ogni grattacielo se saltassi sempre a destra.
	 * Parto dal penultimo (n-1)-1.
	 * Se l'adiacente è più alto lo ignoro
	 * Se l'adiacente ha un trampolino "fondo" i due dandogli il valore pari alla somma e piazzando un trampolino sul risultante
	 * Aggiorno comunque il valore di questo grattacielo facendo un salto sul prossimo
	 */
	//printf("Analisi lato DESTRO\n");
	for (int i = num_skysc-2; i >=0; --i) {
		int next = i+1;
		//printf("Guardo %d° grattacielo: '%d'\n", i + 1, h[i]);
		if (h[i] < h[next]) {
			//printf(" -> E' più basso di quello alla sua dx (%d<%d)\n", h[i], h[next]);
			continue;
		} else {
			//printf(" -> E' più alto di quello alla sua dx (%d>%d)\n", h[i], h[next]);
			if (tramp[next] == 'T') {
				//printf(" -> Il grattacielo alla sua dx ha il trampolino\n",h[i], h[next]);
				//printf(" -> Aggiungo il trampolino");
				tramp[i] = 'T';
			}
			dx_value[i] = 1 + dx_value[next];
			//printf(" -> Nuovo valore: %d\n", dx_value[i]);
		}
	}
	//printf("\n");

	/**
	 * Calcolo i valori massimi per ogni grattacielo.
	 * Devo capire se conviene saltare su 'i'.
	 * Il suo valore è infatti 1 + il massimo tra SX(i) e DX(i)
	 * Nel frattempo conto i trampolini, perchè essi sono "salti sicuri"
	 */
	//printf("Scansione per il valore massimo\n");
	int T = 0, best = 0;
	for (int i = 0; i < num_skysc; i++) {
		//printf("Guardo %d° grattacielo: '%d'\n", i + 1, h[i]);
		if (tramp[i] == 'T') {
			++T;
			//printf(" -> Ha il trampolino: (T=%d)\n",T);
		} else {
			best = max(best, 1 + max(sx_value[i], dx_value[i]));
			//printf(" -> Non ha il trampolino\n",T);
			//printf(" -> SX: %d - DX: %d -> best=%d\n",sx_value[i], dx_value[i], best);
		}
	}

	fout = fopen("output.txt", "w");

	/**
	 * A questo punto ho ottenuto quale grattacielo mi da il valore massimo possibile.
	 * Esso è raggiungibile direttamente se parto da un trampolino.
	 * Altrimenti inizio a guardare quanti salti posso fare a sinistra e quanti a destra.
	 * Guardo solo quelli che hanno altezza uguale.
	 * Li visito tutti (dx-sx) e quindi prendo il valore massimo tra quelli dei due estremi (che sono certo essere già i migliori)
	 */
	printf("Calcolo del risultato\n");
	if (tramp[startPosition] == 'T') {
		fprintf(fout, "%d\n", T + best);
		printf(" -> Ho il trampolino in prima posizione! Valore massimo: %d\n", T + best);
	} else {
		printf(" -> Non ho il trampolino in prima posizione\n");
		int sx = startPosition, dx = startPosition;
		while (sx > 0 && h[sx - 1] == h[startPosition]) {
			sx--;
		}
		while (dx < (num_skysc - 1) && h[dx + 1] == h[startPosition]) {
			dx++;
		}
		fprintf(fout, "%d\n", 1 + (dx - sx) + max(sx_value[sx], dx_value[dx]));
		printf(" -> Valore massimo: %d\n", 1 + (dx - sx) + max(sx_value[sx], dx_value[dx]));
	}

	fclose(fout);

	return 0;
}

/**
 * Semplice funzione per calcolare il massimo tra due numeri
 */
int max(int x, int y) {
	if (x >= y)
		return x;
	else
		return y;
}

void printSkysc() {
	printf("Grattacieli:\n");
	for (int i = 0; i < num_skysc; i++) {
		printf("\t%d", i + 1);
	}
	printf("\n");
	for (int i = 0; i < num_skysc; i++) {
		printf("\t%d", h[i]);
	}
	printf("\n");
	for (int i = 0; i < num_skysc; i++) {
		printf("\t%c", tramp[i]);
	}
	printf("\n\n");
}

