#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <sstream>
#include <vector>

#define APERTA '('
#define CHIUSA ')'
#define ELIMINA '-'

// lettura file
std::vector<std::string> readFile(const char* filename)
{
	std::vector<std::string> input;

	FILE* fp = fopen(filename,"r");
	if(fp == NULL)
	{
		return input;
	}

	fseek(fp,0,SEEK_END);
	int size = ftell(fp);
	fseek(fp,0,SEEK_SET);

	char* buffer = (char*)malloc(sizeof(char)*size);
	if(fread(buffer,1,size,fp) == 0)
	{
		delete buffer;
		return input;
	}

	for(int i=0; i<size; i++)
	{
		std::string line;
		while(buffer[i] != '\n' && buffer[i] != '\0')
		{
			line += buffer[i];
			i++;
		}
		input.push_back(line);
	}

	fclose(fp);
	
	return input;
}

// passo come argomento il nome del file di input
int main(int argc, char* argv[])
{
	std::vector<std::string> input = readFile("input.txt");
	int size = input.size();
	if(size == 0)
		return EXIT_FAILURE;

	int N = atoi(input[0].c_str());
	std::string P = input[1];

	int SOLUZIONE = 0;

	// sistemo le parentesi più esterne

	if(P[0] == CHIUSA)
	{
		P[0] = APERTA;
		SOLUZIONE++;
	}
	if(P[N-1] == APERTA)
	{
		P[N-1] = CHIUSA;
		SOLUZIONE++;
	}

	int da = 1;
	int a = N-2;

	while(a-da >= 0)
	{
		if(a==da)
		{
			P[da] = ELIMINA;
			SOLUZIONE++;
			break;
		}

		if(P[da] == P[a])
		{
			if(P[da] == APERTA)
			{
				P[a] = CHIUSA;
				SOLUZIONE++;
			}
			else
			{
				P[a] = APERTA;
				SOLUZIONE++;
			}
		}
		da++;
		a--;
	}

	FILE* fp = fopen("output.txt","wb");
	std::stringstream ss;
	ss << SOLUZIONE;
	std::string solution = ss.str();
	fwrite(solution.c_str(),solution.size(),sizeof(char),fp);
	fclose(fp);

	return EXIT_SUCCESS;
}







































// EOF
