#include <iostream>
#include <fstream>
#include <cassert>
#include <stdio.h>

using namespace std;

const int MAX_N = 1000000;
char arr[MAX_N];
int n;
int open_wrong;
int closed_wrong;

int moves;

inline void preprocess();
inline void destroy(int left, int right);
inline void countWrong();
void printArr();

int main() {
	ifstream fin("input.txt"); assert( fin );
  	fin >> n;

	for (int i=0; i<n; i++) {
		fin >> arr[i];
	}

	//printArr();
	preprocess();
	//printArr();
	countWrong();


	//l'idea è che al termine della fase di preprocessing nella stringa incontreremo
	//prima solo parentesi chiuse e poi solo parentesi aperte, per ogni coppia di chiuse
	//o per ogni coppia di aperte è sufficiente una mossa per ribaltarne una e sistemerle entrambe
	//+ una mossa di eliminazione per eventuali parentesi che non hanno una coppia della stessa forma
	moves = open_wrong/2 + open_wrong%2 + closed_wrong/2 + closed_wrong%2;

	ofstream fout("output.txt"); assert( fout );
	fout << moves;
	fout.close();
	
	return 0;
}

//scansiona l'array una sola volta partendo dalla seconda posizione
//e quando incontra una parentesi chiusa invoca il metodo destroy
inline void preprocess() {
	for (int i=1; i<n; i++) {
		if (arr[i]==')') {
			destroy(i-1,i);
		}
	}
}

//distrugge tutte le parentesi ben accoppiate
inline void destroy(int left, int right) {
	while (left>=0 && right<n) {
		if (arr[left]=='(' && arr[right]==')') {
			arr[left]=arr[right]='.';
			right++;
			left--;
		} else if (arr[left]=='.' && arr[right]==')') {
			left--;
		} else break;
	}
}

//conta quante parentesi sbagliate ci sono al termine della
//fase di preprocessing
inline void countWrong() {
	for (int i=0; i<n; i++) {
		if (arr[i]=='(') open_wrong++;
		if (arr[i]==')') closed_wrong++;
	}
}

//metodo utile solo ai fini di debug
void printArr() {
	for (int i=0; i<n; i++) {
		printf("%c ",arr[i]);
	}
	printf("\n");
}


