#define NDEBUG

#define MAX 10000
#define K 100 

#include <cassert>
#include <fstream>
#include <cstdlib>
#include <vector>

#ifndef NDEBUG
    #include <iostream>
#endif

using namespace std;

int even_or_odd(int *v, int size, int *max);
bool is_sorted(int *v, int size);
int find(int n, int* v, int size);
void sort(int *v, int size);
void sort(int *v, int size, ofstream *fout);

int main(){

    int n, k;
    int **p;
    int sl = 0;
    int number_of_moves = 0;
    int maxV[1];

    maxV[0] = 0;

    vector<int *> solution;
    ifstream fin("input.txt"); assert(fin);

    fin >> n;
    fin >> k;

    int toSolve[k];

    p = (int**) malloc(sizeof(int**) * k);

    for (int i = 0; i < k; i++)
        p[i] = (int*) malloc(sizeof(int*) * n);

    for (int i = 0; i < k; i++)
	for (int j = 0; j < n; j++)
		fin >> p[i][j];
    //cout << " n " << n << " k " << k << endl;    
    for (int i = 0; i < k; i++){
        toSolve[i] = even_or_odd(p[i], n, maxV);
        sl += toSolve[i];
	//cout << toSolve[i] << "  " << endl;
    }

    //cout << "SL " << sl << " K/2 " << k/2 << endl;

    ofstream fout("output.txt");

    if (sl > k/2){ //Risolvo gli sl dispari (1)
	//cout << "Risolvo i dispari" << endl;
        int end = 0;
        fout << sl << " " << maxV[0] << endl;

        for (int i = 0; i < k; i++){
            if ((toSolve[i] == 1) && !is_sorted(p[i], n))
                end = 1;	
            }
            while (end == 1){ //Risolvi
	       end = 0;

	       for (int i = 0; i < k; i++){
	           sort(p[i], n, &fout);
	       }
	       fout << endl;

		for (int i = 0; i < k; i++){
		    if ((toSolve[i] == 1) && !is_sorted(p[i], n))
		        end = 1;
		}
        }
        return 0;
    }

    else { // Risolvo i (k - sl) pari (0)
	//cout << "Risolvo i pari" << endl;
	int sl1 = (k-sl);
	int end = 0;
	
	fout << sl1 << " " << maxV << endl;

        for (int i = 0; i < k; i++){
            if ((toSolve[i] == 1) && !is_sorted(p[i], n))
                end = 1;	
        }
        while (end == 1){ //Risolvi
	    end = 0;
            for (int i = 0; i < k; i++){
                sort(p[i], n, &fout);
            }
	    fout << endl;

            for (int i = 0; i < k; i++){
                if ((toSolve[i] == 1) && !is_sorted(p[i], n))
                    end = 1;
            }
        }
        return 0;
    }
}

bool is_sorted(int *v, int size){
    for(int i = 0; i < size; i++)
        if(v[i] != (i+1)) return false;
    return true;
}

int find(int n, int* v, int size){
    for(int i = 0; i < size; i++)
        if (v[i] == n)
            return i;
}

void sort(int *v, int size){
    for(int i = 0; i < size; i++)
        if(v[i] != (i+1)){
            int index = find((i+1), v, size);
            int temp = v[i];
            v[i] = v[index];
            v[index] = temp;
            return;
        }

}

void sort(int *v, int size, ofstream *fout){

    if (is_sorted(v, size)){
        int temp = v[0];
        v[0] = v[1];
        v[1] = temp;
	*fout << "1 2 ";
        return;
    }
    for(int i = 0; i < size; i++){
        if(v[i] != (i+1)){
            int index = find((i+1), v, size);
            int temp = v[i];
            v[i] = v[index];
            v[index] = temp;
	    *fout << (i+1) << " " << (index +1) << " ";
            return;
        }
    }
}

int even_or_odd(int *v, int size, int *max){
    int n = 0;

    if (is_sorted(v, size))
	return 0;

    int *temp;
    temp = (int *) malloc(sizeof(int*)*size);
    for (int i =0; i<size; i++)
	temp[i] = v[i];
    while (!is_sorted(temp,size)){
	n++;
	sort(temp, size);
    }
   //cout << "Esco " << endl;
    if (max[0] < n)
	max[0] = n;

    // Ritorno 1 se numero di mosse dispari 0 se pari
    return (n % 2);
}
