#include <fstream>

inline int max(int one, int two)
{
	return one>two ? one : two;
}

const int NN = 300000;
int heights[NN], left[NN], right[NN];
char trampoline[NN];

int main(int argc,char* argv[])
{
	int n,k;
	std::ifstream ifile("input.txt");
	std::ofstream ofile("output.txt");
	ifile >> n >> k;
	--k;

	for(int i = 0; i < n; ++i)
	{
		ifile >> heights[i];
		left[i]=0;
		right[i]=0;
	}


	ifile >> trampoline;

	for(int i = 1; i < n; ++i)
	{
		if(heights[i] < heights[i-1])
			continue;
		if(trampoline[i-1] == 'T')
			trampoline[i] = 'T';
		left[i] = 1 + left[i-1];
	}

	for(int i = n-2; i >= 0; --i)
	{
		if(heights[i] < heights[i+1])
			continue;
		if(trampoline[i+1] == 'T')
			trampoline[i] = 'T';
		right[i] = 1 + right[i+1];
	}

	int T=0, best=0;
	for(int i=0; i<n; ++i)
	{
		if(trampoline[i] == 'T')
			++T;
		else
			best = max(best, 1+max(left[i],right[i]));
	}

	if(trampoline[k] == 'T')
	{
		ofile << T + best << std::endl;
	}
	else
	{
		int l=k, r=k;
		while(l > 0 && heights[l-1] == heights[k])
			l--;
		while(r < n-1 && heights[r+1] == heights[k])
			r++;
		ofile << (r-l+1+max(left[l],right[r])) << std::endl;
	}
	
	return 0;
}
