/* FILE: editFormula.cpp   last change: 02-Jul-2013   author: Alex Malfatti
 * a solver for problem editFormula
 */

//#define NDEBUG   // NDEBUG definita nella versione che consegno
#include <cassert>
#ifndef NDEBUG
#  include <iostream>  // uso di cin e cout non consentito in versione finale
#endif
#include <fstream>

using namespace std;

const int MAX_N = 1000000;

int n;
int numberOfOperations = 0;
char fbf[MAX_N];

void cancella(int pos) {
	n--;	
	for(int i = pos; i < n; i++) {
		fbf[pos] = fbf[pos+1];  
	}
	numberOfOperations++;
}

void inserisci(int pos, char type) {
	n++;	
	char temp = fbf[pos];
	fbf[pos] = type;
	for(int i = pos+1; i < n; i++) {
		char tempNext = fbf[i];
		fbf[i] = temp;
		temp = tempNext;
	}
	numberOfOperations++;
}

void ribalta(int pos) {
	if (fbf[pos] == '(')
		fbf[pos] = ')';
	else
		fbf[pos] = '(';
	numberOfOperations++;
}

int main() {
	ifstream fin("input.txt"); assert(fin);
	fin >> n;
	for(int i = 0; i < n; i++)
    	fin >> fbf[i];
	fin.close();

	// se la stringa ha lungezza pari...
	if((n % 2) == 0) {
		for(int i = 0; i < n/2; i++) {
			if(fbf[i] == ')')
				ribalta(i);
		}
		for(int i = n/2; i < n; i++) {
			if(fbf[i] == '(')
				ribalta(i);
		}
	}
	// se la stringa ha lungezza dispari...
	else {
		int contOpen, contClose = 0;
		for(int i = 0; i < n; i++) {
			if(fbf[i] == '(')
				contOpen++;
			else
				contClose++;
		}
		if(contOpen < contClose) {
			if(fbf[0] == ')')
				cancella(0);
			else
				inserisci(0,'(');
		}			
		else {
			if(fbf[n-1] == '(')
				cancella(n-1);
			else
				inserisci(n-1,')');
		}
		
		for(int i = 0; i < n/2; i++) {
			if(fbf[i] == ')')
				ribalta(i);
		}
		for(int i = n/2; i < n; i++) {
			if(fbf[i] == '(')
				ribalta(i);
		}
	}

	ofstream fout("output.txt"); assert(fout);
	fout << numberOfOperations << endl;	
	fout.close();

	return 0;
}

