/* FILE: trampolin.cpp   last change: 02-Jul-2013   author: Alex Malfatti
 * a solver for problem trampolin
 */

//#define NDEBUG   // NDEBUG definita nella versione che consegno
#include <cassert>
#ifndef NDEBUG
#  include <iostream>  // uso di cin e cout non consentito in versione finale
#endif
#include <fstream>

using namespace std;

const int MAX_N = 300000;
const int MAX_K = MAX_N;
//const int MAX_HEIGHT = 10000000;

int N, K = 0;
int jumps = 1;
int skyscraper[MAX_N];
int jumpedSS[MAX_N];
char trampolin[MAX_N];

// maxHeight() trova il palazzo più alto non ancora visitato
void maxHeight() {
	int oldK = K;
	int max = skyscraper[0];
	for(int i = 0; i < N; i++) {
		if((skyscraper[i] >= max) && (jumpedSS[i] == 0))
			K = i;
	}
	if(K != oldK) {
		jumpedSS[K] = 1;
	}
}

// findTrampolin() trova il primo palazzo con un trampolino non ancora visitato
void findTrampolin() {
	int oldK = K;
	int trovato = 0;
	for (int i = 0; i < N; i++) {
		if((trampolin[i] == 'T') && (jumpedSS[i] == 0) && (trovato == 0)) {
			trovato = 1;
			K = i;
			jumpedSS[K] = 1;
		}
	};
	if(K == oldK) {
		maxHeight();
	}
}

int main() {
	ifstream fin("input.txt"); assert(fin);
	fin >> N;
	fin >> K;
	K--;
	for(int i = 0; i < N; i++)
    	fin >> skyscraper[i];
	for(int i = 0; i < N; i++)
    	fin >> trampolin[i];
	fin.close();

	for(int i = 0; i < N; i++)
		jumpedSS[i] = 0;
	jumpedSS[K] = 1;

	//cout << (K+1); 	

	while(((skyscraper[K-1] <= skyscraper[K]) && (jumpedSS[K-1] == 0))
			|| ((skyscraper[K+1] <= skyscraper[K]) && (jumpedSS[K+1] == 0))
			|| ((trampolin[K] == 'T') && (jumps < N))) {

		// se il supereroe non si trova ne sul primo palazzo ne sull'ultimo
		if((K != 0) && (K != (N-1))) {
			if(trampolin[K] == 'T')
				findTrampolin();
			else {
				if((skyscraper[K-1] <= skyscraper[K]) && (skyscraper[K+1] > skyscraper[K])) {
					K--;
					jumpedSS[K] = 1;	
				}
				else if((skyscraper[K+1] <= skyscraper[K]) && (skyscraper[K-1] > skyscraper[K])) {
					K++;
					jumpedSS[K] = 1;	
				}

				else if((skyscraper[K-1] <= skyscraper[K]) && (skyscraper[K+1] <= skyscraper[K])) {
					if(skyscraper[K-1] < skyscraper[K+1]) {
						K++;
						jumpedSS[K] = 1;
					}
					if(skyscraper[K+1] < skyscraper[K-1]) {
						K--;
						jumpedSS[K] = 1;
					}
					if(skyscraper[K-1] == skyscraper[K+1]) {
						if((K-1) < (N/2))
							K--;
						else
							K++;
						jumpedSS[K] = 1;
					}
				}
			}
			jumps++;
			//cout << " -> " << (K+1);
		}

		// se il supereroe si trova sul primo palazzo
		if(K == 0) {
			if(trampolin[K] == 'T')
				findTrampolin();
			else if((skyscraper[K+1] <= skyscraper[K]) && (jumpedSS[K+1] == 0)) {
				K++;
				jumpedSS[K] = 1;
			}
			jumps++;
			//cout << " -> " << (K+1);		
		}	

		// se il supereroe si trova sull'ultimo palazzo
		if(K == (N-1)) {
			if(trampolin[K] == 'T')
				findTrampolin();
			else if((skyscraper[K-1] <= skyscraper[K]) && (jumpedSS[K-1] == 0)) {
				K--;
				jumpedSS[K] = 1;
			}
			jumps++;
			//cout << " -> " << (K+1);	
		}

	}
	
	//cout << endl << "JUMPS: " << jumps << endl;

	ofstream fout("output.txt"); assert(fout);
	fout << jumps << endl;
	fout.close();

	return 0;
}

